/* async_job_limiter.cc
 * This file belongs to Worker, a file manager for UN*X/X11.
 * Copyright (C) 2021 Ralf Hoffmann.
 * You can contact me at: ralf@boomerangsworld.de
 *   or http://www.boomerangsworld.de/worker
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "async_job_limiter.hh"

static const size_t JOB_LIMIT = 1000;
std::atomic< size_t > AsyncJobLimiter::count{0};

size_t AsyncJobLimiter::open_async_jobs()
{
    return count;
}

bool AsyncJobLimiter::async_job_limit_reached()
{
    if ( count >= JOB_LIMIT ) {
        return true;
    }

    return false;
}

void AsyncJobLimiter::inc_async_job()
{
    count++;
}

void AsyncJobLimiter::dec_async_job()
{
    count--;
}
